/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.core.internals;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Date;
import com.silverwrist.venice.core.ConferenceContext;
import com.silverwrist.venice.db.PostLinkDecoderContext;
import com.silverwrist.venice.except.DataException;

public interface ConferenceBackend
{
  public abstract ConferenceContext selfConference();

  public abstract int realConfID();

  public abstract boolean userCanHide();

  public abstract void touchRead(Connection conn) throws SQLException;

  public abstract void touchPost(Connection conn, java.util.Date post_date) throws SQLException;

  public abstract String realConfAlias();

  public abstract boolean userCanScribble();

  public abstract boolean userCanNuke();

  public abstract boolean userCanRead();

  public abstract boolean userCanPost();

  public abstract void touchUpdate(Connection conn, java.util.Date date) throws DataException;

  public abstract PostLinkDecoderContext createDecoderContext(short topicid);

  public abstract int env_getConfLevel();

  public abstract String env_getConfName();

} // end interface ConferenceBackend
